//
//  brun.c
//
//  Created by Julien-Pierre Avrous on 22/08/06.
//  Copyright 2006 SourceMac.com. All rights reserved.
//
//


#include <stdio.h>
#include "brun.h"

/* > Prototype fonctions internes */
int nextJumFirst(int i);

/* > Fonction d'entree */
float nieme_brun(int n)
{
  int i, j, k;

  for(i=3, k=0; k<=n; k+=2)
    {
      j=nextJumFirst(i);
      i=j+2;
    }
  if(n%2==0)
    return 1./(j);
  else
    return 1./(j+2.);
}

/* > Fonctions internes */

/* Renvois i si i et i+2 sont premiers, renvois le couple premier suivant i si i+2 n'est pas premier.
   i est considere comme premier pour l'appel de cette fonction */
int nextJumFirst(int i)
{
  register int j, z=i, stop=0;

  while(!stop)
    {
    stop=1;
      for(j=2; j<=z/2; j++)
	{
	  if(z%j==0 || (z+2)%j==0)
	    {
	      stop=0;
	      break;
	    }
	}
      z +=2;
      }
  return z-2;
}
